# Polygon

This small C89 library triangulates simple polygons, i.e. polygons whose their
non consecutive edges does not intersect. It relies on the ear-clipping variant
of Xianshu Kong et al. presented in "The Graham Scan Triangulates Simple
Polygons".

## How to build

The library uses [CMake](http://www.cmake.org) and the
[RCMake](https://gitlab.com/vaplv/rcmake/#tab-readme) package to build. It also
depends on the [RSys](https://gitlab.com/vaplv/rsys/#tab-readme) library.
First, install the RCMake package and the RSys library. Then, generate the
project from the cmake/CMakeLists.txt file by appending the RCMake and RSys
install directories to the `CMAKE_PREFIX_PATH` variable. The resulting project
can be edited, built, tested and installed as any CMake project.

## Release notes

### Version 0.1.4

Fix warnings detected by gcc 11

### Version 0.1.3

Sets the CMake minimum version to 3.1: since CMake 3.20, version 2.8 has become
obsolete.

### Version 0.1.2

Update the version of the RSys dependency to 0.6: replace the deprecated
`[N]CHECK` macros by the new macro `CHK`.

## License

Copyright (C) 2014-2017, 2021 Vincent Forest (vaplv@free.fr). Polygon is free
software released under GPL v3+ license: GNU GPL version 3 or later. You are
welcome to redistribute it under certain conditions; refer to the COPYING file
for details.
